'----------------------------------------------------------------------
' ds1302include.bas
'----------------------------------------------------------------------

$lib "ds1302clock.lib"

Config Portc.4 = Output
Config Portc.6 = Output

Ds1302_clock Alias Portc.4                                  ' DS1302 Pin 7 - Clock
Ds1302_io Alias Pinc.5                                      ' DS1302 Pin 6 - I/O
Ds1302_io_port Alias Portc.5
Ds1302_enable Alias Portc.6                                 ' DS1302 Pin 5 - Enable

Declare Sub Ds1302_write(byval Clockcommand As Byte , Clockbyte As Byte)
Declare Function Ds1302_read(byval Clockcomand As Byte) As Byte
Declare Sub Ds1302_set_time(byval Strtime As String)

'----------------------------------------------------------------------
' Ds1302_read
'----------------------------------------------------------------------

Function Ds1302_read(byval Clockcomand As Byte) As Byte

   Dim Readbyte As Byte

   Config Ds1302_io_port = Output

   Set Ds1302_clock

   Set Ds1302_io

   Set Ds1302_enable

   Reset Ds1302_clock

   Reset Ds1302_enable

   Waitus 5

   Set Ds1302_enable

   Waitus 5                                                 'tcc =4us, CE to clock setup time

   Shiftout Ds1302_io_port , Ds1302_clock , Clockcomand , 3

   Config Ds1302_io_port = Input

   Set Ds1302_clock

   Reset Ds1302_io

   Set Ds1302_enable

   Shiftin Ds1302_io , Ds1302_clock , Readbyte , 2

   Reset Ds1302_enable

   Rotate Readbyte , Left , 1

   Waitus 5

   Ds1302_read = Readbyte

End Function

'----------------------------------------------------------------------
' Ds1302_write
'----------------------------------------------------------------------

Sub Ds1302_write(byval Clockcommand As Byte , Clockbyte As Byte)

   Config Ds1302_io_port = Output

   Set Ds1302_clock

   Reset Ds1302_io

   Set Ds1302_enable

   Reset Ds1302_clock

   Reset Ds1302_enable

   Waitus 5

   Set Ds1302_enable

   Waitus 5                                                 'tcc =4us, CE to clock setup time

   Shiftout Ds1302_io_port , Ds1302_clock , Clockcommand , 3

   Shiftout Ds1302_io_port , Ds1302_clock , Clockbyte , 3

   Reset Ds1302_clock

   Waitus 5

   Reset Ds1302_enable

   Waitus 5

End Sub

'----------------------------------------------------------------------
' Getdatetime
'----------------------------------------------------------------------
'
' Reads the date and time from the DS1302 real time clock and stores
' them in the system variables _year, _month, _day, _hour, _min, and
' _sec
'
'----------------------------------------------------------------------

Getdatetime:

   _sec = Ds1302_read(&H81)

   _min = Ds1302_read(&H83)

   _hour = Ds1302_read(&H85)

   _day = Ds1302_read(&H87)

   _month = Ds1302_read(&H89)

   _year = Ds1302_read(&H8d)

  _sec = Makedec(_sec)
  _min = Makedec(_min)
  _hour = Makedec(_hour)
  _day = Makedec(_day)
  _month = Makedec(_month)
  _year = Makedec(_year)

Return

'----------------------------------------------------------------------
' Setdate
'----------------------------------------------------------------------
'
' Writes the date stored in the system variables _year, _month, and
' _day to the DS1302 real time clock.  Called by ds1302clock.lib
'
' To use:
'
' Date$ = "yy-mm-dd"
'
'----------------------------------------------------------------------

Setdate:

   _day = Makebcd(_day)
   Ds1302_write &H86 , _year

   _month = Makebcd(_month)
   Ds1302_write &H88 , _month

   _year = Makebcd(_year)
   Ds1302_write &H8C , _year

Return

'----------------------------------------------------------------------
' Settime
'----------------------------------------------------------------------
'
' Writes the time stored in the system variables _hour, _min, and _sec
' to the DS1302 real time clock.  Called by ds1302clock.lib
'
' To use:
'
' Time$ = "hh:mm:dd"
'
'----------------------------------------------------------------------

Settime:

   _hour = Makebcd(_hour)
   Ds1302_write &H84 , _hour

   _min = Makebcd(_min)
   Ds1302_write &H82 , _min

   _sec = Makebcd(_sec)
   Ds1302_write &H80 , _sec

Return